 // PPgGeneral.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgGeneral.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgGeneral dialog
//CBarShader CPPgGeneral::s_preview(16,16); 

IMPLEMENT_DYNAMIC(CPPgGeneral, CPropertyPage)
CPPgGeneral::CPPgGeneral()
	: CPropertyPage(CPPgGeneral::IDD)
{
}

CPPgGeneral::~CPPgGeneral()
{
}

void CPPgGeneral::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LANGS, m_language);
	//DDX_Control(pDX, IDC_PREVIEW, s_preview);
	DDX_Control(pDX, IDC_PREVIEW, m_3DPreview);
}

BEGIN_MESSAGE_MAP(CPPgGeneral, CPropertyPage)
	ON_EN_CHANGE(IDC_NICK, OnSettingsChange)
	ON_EN_CHANGE(IDC_TOOLTIPDELAY, OnSettingsChange)
	ON_CBN_SELCHANGE(IDC_LANGS, OnSettingsChange)
	ON_BN_CLICKED(IDC_BEEPER, OnSettingsChange)
	ON_BN_CLICKED(IDC_SPLASHON, OnSettingsChange)
	ON_BN_CLICKED(IDC_DBLCLICK, OnSettingsChange)
	ON_BN_CLICKED(IDC_NOTIFY, OnSettingsChange)
	ON_BN_CLICKED(IDC_ONLINESIG, OnSettingsChange)
	ON_BN_CLICKED(IDC_TBSPEEDMETER, OnSettingsChange)
	ON_BN_CLICKED(IDC_LOGTOFILE, OnSettingsChange)
	ON_BN_CLICKED(IDC_MULTIPLE, OnSettingsChange)
	ON_BN_CLICKED(IDC_DC_CLIENT, OnSettingsChange)
	ON_BN_CLICKED(IDC_VERBOSE, OnSettingsChange)
	ON_BN_CLICKED(IDC_A4AF, OnSettingsChange)
	ON_BN_CLICKED(IDC_MP_STANDARD, OnSettingsChange)
	ON_BN_CLICKED(IDC_MP_HIGH, OnSettingsChange)
	ON_BN_CLICKED(IDC_WEBSVEDIT , OnBnClickedEditWebservices)
	ON_WM_HSCROLL()
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_3DDEPTH, On3DDepth)
END_MESSAGE_MAP()

BOOL CPPgGeneral::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	((CEdit*)GetDlgItem(IDC_NICK))->SetLimitText(49);

	// pooz
	const WORD wLangs[] = 
	{
		MAKELANGID(LANG_CATALAN,SUBLANG_DEFAULT),  // Catalonian
		MAKELANGID(LANG_CHINESE,SUBLANG_CHINESE_SIMPLIFIED), // Chinese (simplified)
		MAKELANGID(LANG_CHINESE,SUBLANG_CHINESE_TRADITIONAL), // Chinese (traditional)
		MAKELANGID(LANG_DANISH,SUBLANG_DEFAULT),  // Danish
		MAKELANGID(LANG_DUTCH,SUBLANG_DEFAULT),  // Dutch
		MAKELANGID(LANG_ENGLISH,SUBLANG_DEFAULT),  // English
		MAKELANGID(LANG_FINNISH,SUBLANG_DEFAULT),  // Finnish
		MAKELANGID(LANG_FRENCH,SUBLANG_DEFAULT),  // French
		MAKELANGID(LANG_GERMAN,SUBLANG_DEFAULT),  // German
		MAKELANGID(LANG_GREEK,SUBLANG_DEFAULT),  // Greek
		MAKELANGID(LANG_HEBREW,SUBLANG_DEFAULT),  // Hebrew
		MAKELANGID(LANG_ITALIAN,SUBLANG_DEFAULT),  // Italian
		MAKELANGID(LANG_KOREAN,SUBLANG_DEFAULT),  // Korean
		MAKELANGID(LANG_POLISH,SUBLANG_DEFAULT),  // Polish
		MAKELANGID(LANG_PORTUGUESE,SUBLANG_PORTUGUESE_BRAZILIAN), // Portuguese (Brasilian)
		MAKELANGID(LANG_RUSSIAN,SUBLANG_DEFAULT),  // Russian
		MAKELANGID(LANG_SPANISH,SUBLANG_SPANISH),  // Spanish
		MAKELANGID(LANG_LITHUANIAN,SUBLANG_DEFAULT),  // Lithuanian
		MAKELANGID(LANG_ROMANIAN,SUBLANG_DEFAULT)  // Romanian
	};
	
	TCHAR szLang[128];
	CString strBuffer;	
	for(int i = 0; i < sizeof(wLangs) / sizeof(WORD); i++) 
	{
		GetLocaleInfo(wLangs[i], LOCALE_SLANGUAGE, szLang, sizeof(szLang));
		strBuffer=szLang;
		switch(wLangs[i] & 0xff)			//Cax2 no sublangs in brackets for the following languages
		{
			case	LANG_ENGLISH:
			case 	LANG_GERMAN:
			case 	LANG_FRENCH:
			case 	LANG_SPANISH:
			case 	LANG_DUTCH:
			case	LANG_ITALIAN:
			{	
				int iBracket = strBuffer.Find('(');
				if(iBracket > 0)
					strBuffer.Delete(iBracket, strBuffer.GetLength()-iBracket);
				break;
			}
		}
		m_language.SetItemData(m_language.AddString(strBuffer), wLangs[i]);
	}
	// end pooz
	LoadSettings();
	DrawPreview();
	Localize();

	return TRUE;
}

void CPPgGeneral::LoadSettings(void)
{
	GetDlgItem(IDC_NICK)->SetWindowText(app_prefs->GetUserNick());

	for(int i = 0; i != m_language.GetCount(); i++)
		if(m_language.GetItemData(i) == app_prefs->GetLanguageID())
			m_language.SetCurSel(i);
	
	if (app_prefs->IsOnlineSignatureEnabled())
		CheckDlgButton(IDC_ONLINESIG,1);
	else
		CheckDlgButton(IDC_ONLINESIG,0);
	
	if(app_prefs->IsErrorBeepEnabled())
		CheckDlgButton(IDC_BEEPER,1);
	else
		CheckDlgButton(IDC_BEEPER,0);

	if(app_prefs->UseSplashScreen())
		CheckDlgButton(IDC_SPLASHON,1);
	else
		CheckDlgButton(IDC_SPLASHON,0);

	if(app_prefs->IsDoubleClickEnabled())
		CheckDlgButton(IDC_DBLCLICK,1);
	else
		CheckDlgButton(IDC_DBLCLICK,0);

	if(app_prefs->GetShowToolbarSpeedMeter())
		CheckDlgButton(IDC_TBSPEEDMETER, 1);
	else
		CheckDlgButton(IDC_TBSPEEDMETER, 0);

	if(app_prefs->LogToFile())
		CheckDlgButton(IDC_LOGTOFILE, 1);
	else
		CheckDlgButton(IDC_LOGTOFILE, 0);

	if(app_prefs->GetDetailsOnClick())
		CheckDlgButton(IDC_DC_CLIENT, 1);
	else
		CheckDlgButton(IDC_DC_CLIENT, 0);

	if(app_prefs->IsA4AFStringEnabled())
		CheckDlgButton(IDC_A4AF, 1);
	else
		CheckDlgButton(IDC_A4AF, 0);

	if(app_prefs->GetMultiple())
		CheckDlgButton(IDC_MULTIPLE,1);
	else
		CheckDlgButton(IDC_MULTIPLE,0);

	if(app_prefs->GetVerbose())
		CheckDlgButton(IDC_VERBOSE,1);
	else
		CheckDlgButton(IDC_VERBOSE,0);

	switch(app_prefs->GetMainProcessPriority())
	{
		case 0:
			CheckDlgButton(IDC_MP_STANDARD,1);
			break;
		case 1:
			CheckDlgButton(IDC_MP_HIGH,1);
			break;
		default:
			CheckDlgButton(IDC_MP_HIGH,1);
			break;
	}

	CString strBuffer;
	strBuffer.Format("%d", app_prefs->GetToolTipDelay());
	GetDlgItem(IDC_TOOLTIPDELAY)->SetWindowText(strBuffer);

	CSliderCtrl *slider3D = (CSliderCtrl*)GetDlgItem(IDC_3DDEPTH);
	slider3D->SetRange(-5, 5, true);
	int tmp=app_prefs->Get3DDepth();
	if (tmp>10) tmp=tmp-256;
	slider3D->SetPos(tmp);

	SetModified(FALSE);
}

BOOL CPPgGeneral::OnApply()
{
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

	if(m_bModified)
	{
		char buffer[550];
		if(GetDlgItem(IDC_NICK)->GetWindowTextLength())
		{
			GetDlgItem(IDC_NICK)->GetWindowText(buffer,50);
			app_prefs->SetUserNick(buffer);
		}
		if (m_language.GetCurSel() != CB_ERR){
			WORD byNewLang =  m_language.GetItemData(m_language.GetCurSel());
			if (app_prefs->GetLanguageID() != byNewLang){
				app_prefs->SetLanguageID( byNewLang);
				if ( theApp.glob_prefs->IsNTBased() )
				{
					SetThreadLocale(byNewLang);
				}
				theApp.emuledlg->preferenceswnd.Localize();
				theApp.emuledlg->statisticswnd.Localize();
				theApp.emuledlg->serverwnd.Localize();
				theApp.emuledlg->transferwnd.Localize();
				theApp.emuledlg->searchwnd.Localize();
				theApp.emuledlg->sharedfileswnd.Localize();
				theApp.emuledlg->chatwnd.Localize();
				theApp.emuledlg->Localize();
				theApp.emuledlg->ircwnd.Localize();
			}
		}
	
		app_prefs->SetErrorBeepEnabled((int8)IsDlgButtonChecked(IDC_BEEPER));
		app_prefs->SetUseSplashScreen((int8)IsDlgButtonChecked(IDC_SPLASHON));
		app_prefs->SetDoubleClickEnabled((int8)IsDlgButtonChecked(IDC_DBLCLICK));
		app_prefs->SetOnlineSignatureEnabled((int8)IsDlgButtonChecked(IDC_ONLINESIG));
		app_prefs->SetShowToolbarSpeedMeter((int8)IsDlgButtonChecked(IDC_TBSPEEDMETER));
		app_prefs->SetLogToFile((int8)IsDlgButtonChecked(IDC_LOGTOFILE));
		app_prefs->SetDetailsOnClick((int8)IsDlgButtonChecked(IDC_DC_CLIENT));
		app_prefs->SetA4AFStringEnabled((int8)IsDlgButtonChecked(IDC_A4AF));
		app_prefs->SetMultiple((int8)IsDlgButtonChecked(IDC_MULTIPLE));
		app_prefs->Set3DDepth(((CSliderCtrl*)GetDlgItem(IDC_3DDEPTH))->GetPos());
		if (app_prefs->GetVerbose()!=(bool)IsDlgButtonChecked(IDC_VERBOSE))
		{
			app_prefs->SetVerbose((int8)IsDlgButtonChecked(IDC_VERBOSE));
			theApp.emuledlg->serverwnd.ToggleDebugWindow();
			if(IsDlgButtonChecked(IDC_VERBOSE))
				{
					AddLogLine(false,"%s: %s",GetResString(IDS_VERBOSE), GetResString(IDS_ENABLED).MakeLower());
				} else {
					AddLogLine(false,"%s: %s",GetResString(IDS_VERBOSE), GetResString(IDS_DISABLED).MakeLower());
				}
		}
		
		GetDlgItem(IDC_TOOLTIPDELAY)->GetWindowText(buffer,20);
		if(atoi(buffer) > 60)
			app_prefs->SetToolTipDelay(60);
		else
			app_prefs->SetToolTipDelay( atoi(buffer));
		((CemuleDlg*)AfxGetMainWnd())->transferwnd.m_ttip.SetDelayTime(TTDT_INITIAL, theApp.glob_prefs->GetToolTipDelay()*1000);
		
		if(IsDlgButtonChecked(IDC_MP_STANDARD))
		{
			app_prefs->SetMainProcessPriority(0);
		}
		else
		{
			app_prefs->SetMainProcessPriority(1);
		}
		
		theApp.emuledlg->transferwnd.downloadlistctrl.SetStyle();
		theApp.emuledlg->toolbar.ShowSpeedMeter(app_prefs->GetShowToolbarSpeedMeter());
	
		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgGeneral::Localize(void)
{
	if(m_hWnd)
	{
		SetWindowText(GetResString(IDS_PW_GENERAL));
		GetDlgItem(IDC_NICK_FRM)->SetWindowText(GetResString(IDS_PW_NICK));
		GetDlgItem(IDC_LANG_FRM)->SetWindowText(GetResString(IDS_PW_LANG));
		GetDlgItem(IDC_MISC_FRM)->SetWindowText(GetResString(IDS_PW_MISC));
		GetDlgItem(IDC_BEEPER)->SetWindowText(GetResString(IDS_PW_BEEP));
		GetDlgItem(IDC_SPLASHON)->SetWindowText(GetResString(IDS_PW_SPLASH));
		GetDlgItem(IDC_DBLCLICK)->SetWindowText(GetResString(IDS_PW_DBLCLICK));
		GetDlgItem(IDC_TOOLTIPDELAY_LBL)->SetWindowText(GetResString(IDS_PW_TOOL));
		GetDlgItem(IDC_ONLINESIG)->SetWindowText(GetResString(IDS_PREF_ONLINESIG));	
		GetDlgItem(IDC_TBSPEEDMETER)->SetWindowText(GetResString(IDS_PW_SHOWTOOLBARSPEEDMETER));
		GetDlgItem(IDC_LOGTOFILE)->SetWindowText(GetResString(IDS_LOGTOFILE));
		GetDlgItem(IDC_MULTIPLE)->SetWindowText(GetResString(IDS_MULTIPLE));
		GetDlgItem(IDC_DC_CLIENT)->SetWindowText(GetResString(IDS_DC_CLIENT));
		GetDlgItem(IDC_3DDEP)->SetWindowText(GetResString(IDS_3DDEP));
		GetDlgItem(IDC_VERBOSE)->SetWindowText(GetResString(IDS_VERBOSE));
		GetDlgItem(IDC_A4AF)->SetWindowText(GetResString(IDS_A4AF));
		GetDlgItem(IDC_MAINPROCESS)->SetWindowText(GetResString(IDS_MAINPROCESS_LBL));
		GetDlgItem(IDC_MP_STANDARD)->SetWindowText(GetResString(IDS_HASHPRIO_STANDARD));
		GetDlgItem(IDC_MP_HIGH)->SetWindowText(GetResString(IDS_PRIOHIGH));
		GetDlgItem(IDC_WEBSVEDIT)->SetWindowText(GetResString(IDS_WEBSVEDIT));
	}
}

void CPPgGeneral::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);
	UpdateData(false); 
	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}
void CPPgGeneral::OnPaint()
{
	CPropertyPage::OnPaint();
	DrawPreview();
}

void CPPgGeneral::DrawPreview()
{
	m_3DPreview.SetSliderPos(((CSliderCtrl*)GetDlgItem(IDC_3DDEPTH))->GetPos());
/*	CDC* pDC(GetDlgItem(IDC_PREVIEW)->GetWindowDC());
	RECT outline_rec;
	outline_rec.top=0;
	outline_rec.bottom=18;
	outline_rec.left=0;
	outline_rec.right=18;
	pDC->FrameRect(&outline_rec, &CBrush(RGB(127,127,127)));
	s_preview.SetFileSize(16);
	s_preview.Fill(RGB(192,192,255)); 
	s_preview.DrawPreview(pDC, 1, 1, ((CSliderCtrl*)GetDlgItem(IDC_3DDEPTH))->GetPos()); 
	GetDlgItem(IDC_PREVIEW)->ReleaseDC(pDC);*/

}

void CPPgGeneral::On3DDepth(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	DrawPreview();
	*pResult = 0;
}

void CPPgGeneral::OnBnClickedEditWebservices(){
	ShellExecute(NULL, "open", theApp.glob_prefs->GetTxtEditor(), "\""+CString(theApp.glob_prefs->GetAppDir())+"webservices.dat\"", NULL, SW_SHOW); 
}
