//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"
#include "emuleDlg.h"
#include "knownfilelist.h"
#include "preferences.h"
#include "sockets.h"
#include "serverlist.h"
#include "sharedfilelist.h"
#include "searchlist.h"
#include "listensocket.h"
#include "uploadqueue.h"
#include "downloadqueue.h"
#include "clientlist.h"
#include "clientcredits.h"
#include "friendlist.h"
#include "filehashcontrol.h" // Lord KiRon
#include "clientudpsocket.h"
#include "mdump.h"
#include "IPFilter.h"
#include "Loggable.h"
#include <afxmt.h>

#ifdef _USE_BERKELEY_DB
#include "BerkeleyDb/build_win32/db_cxx.h"
#endif //_USE_BERKELEY_DB

class CSearchList;
class CUploadQueue;
class CListenSocket;
class CDownloadQueue;
class CWebServer; // kuchin

class CemuleApp : public CWinApp, public CLoggable
{
public:
	enum AppState{APP_STATE_RUNNING=0,APP_STATE_SHUTINGDOWN,APP_STATE_DONE};	// moved from emuldlg [FoRcHa]

	CemuleApp();
	CemuleDlg*			emuledlg;
	CClientList*		clientlist;
	CKnownFileList*		knownfiles;
	CPreferences*		glob_prefs;
	CServerConnect*		serverconnect;
	CServerList*		serverlist;	
	CSharedFileList*	sharedfiles;
	CSearchList*		searchlist;
	CListenSocket*		listensocket;
	CUploadQueue*		uploadqueue;
	CDownloadQueue*		downloadqueue;
	CClientCreditsList*	clientcredits;
	CFriendList*		friendlist;
	CClientUDPSocket*	clientudp;
	CWebServer*			webserver; // kuchin
	virtual BOOL		InitInstance();
	CString*			pendinglink;
	tagCOPYDATASTRUCT  	sendstruct; // Cax2
	CFileHashControl 	m_FilesHashing; // Lord KiRon
	CMutex				hashing_mut;
	CIPFilter*			ipfilter;
	
	uint64				stat_sessionReceivedBytes;
	uint64				stat_sessionSentBytes;
	uint16				stat_reconnects;
	DWORD				stat_transferStarttime;
	DWORD				stat_serverConnectTime;
	uint16				stat_filteredclients;

#ifdef _USE_BERKELEY_DB
	DbEnv*	pDbEnv;	// Database environment
	Db*		pDbSLS;	// Stored sources

#endif //_USE_BERKELEY_DB

	CArray<CString,CString> webservices;

// Implementierung
	// ed2k link functions
	CString		StripInvalidFilenameChars(CString strText, bool bKeepSpaces = true);
	CString		CreateED2kLink( CAbstractFile* f );
	CString		CreateED2kSourceLink( CAbstractFile* f );
	CString		CreateHTMLED2kLink( CAbstractFile* f );
	bool		CopyTextToClipboard( CString strText );
	CString		CopyTextFromClipboard(); //<<-- enkeyDEV(Ottavio84) -Download all ed2ks in clipboard-
	void		OnlineSig(); 
	void		UpdateReceivedBytes(int32 bytesToAdd);
	void		UpdateSentBytes(int32 bytesToAdd);

	DECLARE_MESSAGE_MAP()
protected:
	bool ProcessCommandline();
	void SetTimeOnTransfer();
	static BOOL CALLBACK SearchEmuleWindow(HWND hWnd, LPARAM lParam);
	void OnHelp();

public:
	AppState	m_app_state; // defines application state for shutdown 
	virtual int ExitInstance();

private:
	MiniDumper *m_pDump;
	HANDLE m_hMutexOneInstance;
};
extern CemuleApp theApp;